#!/usr/bin/perl -w

#Nisus Macro Block
#source front
#destination none
#End Nisus Macro Block

# Modified 04.11.08.

use strict;
use warnings;

my $filepath = $ARGV[1];
# my $filepath = "/Volumes/myDocument/Users/ni/Documents/Backup/Texts J/Conf_Vienne_04_05/article/Vienna_Iyanaga3-test.rtf";

if ("$filepath" eq "") {
	print STDERR "NOT SAVED YET!\n";
	exit;	
	}
	
my $filetype = `file "$filepath"`;

if ($filetype !~ /Rich Text Format/) {
	print STDERR "This is not RTF!\n";
	exit;	
	}

my $tmppath = $filepath;
$tmppath =~ s/^.+\/([^\/]+)(\.[^.]*)?$/$1/;
	# remove folder path
$tmppath =~ s/^(.+)\.rtf$/$1/;
	# remove '.rtf'
$tmppath = '/tmp/'.$tmppath.'_'.$$.'.rtf';

# my $filepath = "/Volumes/myDocument/Users/ni/Documents/Backup/Texts J/Conf_Vienne_04_05/article/Vienna_Iyanaga3-test.rtf";

local undef $/;

open(IN, $filepath) || die ("Couldn't open file $filepath: $!");

open(OUT, '>', $tmppath) || die ("Couldn't open file $filepath: $!");

$_ = <IN>;

/^(\{\\rtf1.+?)(\{\\header .+)(\}[\n\r]*)/s;

my $rtfheader = $1;
my $rtfdata = $2;
my $rtffooter = $3;

# print $rtfheader, "\n\n", $rtfdata, "\n\n", $rtffooter; exit;

$rtfheader =~ /^(\{\\rtf1.+?\{\\fonttbl )(\{\\f0.+?;\})([\n\r]?\})/s;
my $rtf_firstheader = $1;
my $fonttbl = $2;
my $rtf_fonttble_footer = $3 . $';

# $rtfheader =~ /(\{\\stylesheet )(\{\\s\d+ .+?;\})([\n\r]?\})/s;
my $stylesheet = &extract_rtf_token ("stylesheet", $_);
# print $stylesheet, "\n";
my @styles = split (/;\}[\n\r]*/s, $stylesheet);

my %f_estyle;

for my $style (@styles) {
	$style =~ s/\n//g;
	my ($style_id) = $style =~ /(s\d+|cs\d+)/s;
	if ($style =~ /nisusnoteplacement0/s) {
		$f_estyle{'footnote'} = $style_id;
		my ($fnref) = $style =~ /nisusreferencestyle(\d+)/;
		$fnref = "cs" . $fnref;
		$f_estyle{'footnote_ref'} = $fnref;		
	}
# 	if ($style =~ /footnote reference/s) {
# 		$f_estyle{'footnote_ref'} = $style_id;
# 	}
# 	if ($style =~ /Endote Reference/s) {
# 		$f_estyle{'endnote_ref'} = $style_id;
# 	}
	if ($style =~ /nisusnoteplacement2/s) {
		$f_estyle{'endnote'} = $style_id;
		my ($enref) = $style =~ /nisusreferencestyle(\d+)/;
		$enref = "cs" . $enref;
		$f_estyle{'endnote_ref'} = $enref;		
	}
}
# print "footnote = $f_estyle{'footnote'}\nfootnote_ref = $f_estyle{'footnote_ref'}\nendnote = $f_estyle{'endnote'}\nendnote_ref = $f_estyle{'endnote_ref'}\n";

$_ = $rtfdata;

s/\{\\$f_estyle{'endnote_ref'}( \\f\d+ .+?\{\\footnote )(\\ftnalt )(.+? ){\\$f_estyle{'endnote'} \{\\$f_estyle{'endnote_ref'} /\{\\$f_estyle{'footnote_ref'}$1$3\\$f_estyle{'footnote'} \{\\$f_estyle{'footnote_ref'}/sg;
# endnotes -> footnotes
# $1 = ( \\f\d+ .+?\{\\footnote )
# $2 = (\\ftnalt )
# $3 = (.+? )

s/\{\\$f_estyle{'footnote_ref'}( \\f[0-9]+ .+?\{\\footnote )(.+?\{)\\$f_estyle{'footnote'} \{\\$f_estyle{'footnote_ref'}/\{\\$f_estyle{'endnote_ref'}$1\\ftnalt $2\\$f_estyle{'endnote'} \{\\$f_estyle{'endnote_ref'}/sg;
# footnotes -> endnotes
# $1 = ( \\f\d+ .+?\{\\footnote )
# $2 = (.+?\{)

# print $rtfheader . $_ . $rtffooter;

print OUT $rtfheader . $_ . $rtffooter;

close(IN);
close(OUT);

`open -a "Nisus Writer Express" "$tmppath"`;

########

sub extract_rtf_token {
	my $keyword = shift;
	my $str = shift;
	
	if (! $str) {
		return ("");
	}

	my $res;

	my $num = $str =~ s/^(.*?)(\{\\$keyword.+)$/$2/s;
	if (! $num || ! $str) {
#		die ("sub extract_rtf_token couldn't find the keyword...");
		return ("");
	}

	my $pat = '.*?\}';
	($res) = $str =~/^($pat)/s;
	if (! $res) {
		die ("sub extract_rtf_token couldn't find the matching close brace...");
	}
	my $temp = $res;
	my $temp2 = $temp;
	if ($temp =~ s/\{//sg == $temp2 =~ s/\}//sg) {
		return $res;
	}
	else {
		$num = 0;
		while (1) {
			$num++;
			my $pat2 = $pat x $num;
			($res) = $str =~/^(\{$pat2)/s;
			if (! $res) {
				die ("sub extract_rtf_token couldn't find the matching close brace...");
			}
			$temp = $res;
			$temp2 = $temp;
			if ($temp =~ s/\{//sg == $temp2 =~ s/\}//sg) {
				return $res;
			}
		}
	}
}

